#include <stdio.h>

int check(int a[8][8], int i, int j, int n){
    if(i<0 || i>7 || j<0 || j>7 || n+1>a[i][j]) return 0;
    a[i][j]=n+1;
    return 1;
}

void print(int a[8][8]){
    int i, j;
    for(i=0; i<8; i++){
        for(j=0; j<8; j++)
            if (a[i][j]==64) printf(" __");
            else printf(" %2d", a[i][j]);
        printf("\n");
    }
    printf("\n");
}


int knight(int a[8][8], int i, int j){
    if (a[i][j]==63) return 1;
    if (check(a, i+2, j-1, a[i][j])){
        if (knight(a,i+2,j-1)) return 1;
        a[i+2][j-1]=64;
    }
    if (check(a, i+2, j+1, a[i][j])){
        if (knight(a,i+2,j+1)) return 1;
        a[i+2][j+1]=64;
    }
    if (check(a, i+1, j+2, a[i][j])){
        if (knight(a,i+1,j+2)) return 1;
        a[i+1][j+2]=64;
    }
    if (check(a, i-1, j+2, a[i][j])){
        if (knight(a,i-1,j+2)) return 1;
        a[i-1][j+2]=64;
    }
    if (check(a, i-2, j-1, a[i][j])){
        if (knight(a,i-2,j-1)) return 1;
        a[i-2][j-1]=64;
    }
    if (check(a, i-2, j+1, a[i][j])){
        if (knight(a,i-2,j+1)) return 1;
        a[i-2][j+1]=64;
    }
    if (check(a, i+1, j-2, a[i][j])){
        if (knight(a,i+1,j-2)) return 1;
        a[i+1][j-2]=64;
    }
    if (check(a, i-1, j-2, a[i][j])){
        if (knight(a,i-1,j-2)) return 1;
        a[i-1][j-2]=64;
    }
    /* print(a); */
    return 0;
}

int main(){
    int a[8][8]={64}, i, j;
    for(i=0; i<8; i++)
        for(j=0; j<8; j++) a[i][j]=64;
    a[0][0]=0;
    print(a);
    knight(a,0,0);
    print(a);
}
