/* Perimetro di un poligono */

#include <stdio.h>
#include <math.h>

typedef struct { 
    float x; 
    float y;
} punto;

#define N 5

typedef punto poligono[N];

int main(){
    poligono p = { {0, 0}, {0, 1}, {1, 1}, {2, 2}, {2,0}  };
    float peri = 0;
    int i;
    for(i=0; i<N; i++) {
        int j=(i+1)%N;
        float dx = p[i].x-p[j].x;
        float dy = p[i].y-p[j].y;
        peri += sqrt ( dx*dx + dy*dy );
        printf("i=%d : dx=%f, dy=%f\n", i, dx, dy);
    }
    printf("Perimetro = %f\n", peri);
    return 0;
}
